using System;
using System.Linq;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.navigationView.SelectionChanged    += navigationView_SelectionChanged;
            this.leftModeRadioButton.Checked        += leftModeRadioButton_Checked;
            this.topModeRadioButton.Checked         += topModeRadioButton_Checked;
            this.leftCompactModeRadioButton.Checked += leftCompactModeRadioButton_Checked;

            this.navigationView.SelectedItem = this.navigationView.MenuItems.OfType<NavigationViewItem>().First();

            this.leftModeRadioButton.IsChecked = true;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region ׺̼    óϱ - navigationView_SelectionChanged(sender, e)

        /// <summary>
        /// ׺̼    óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void navigationView_SelectionChanged(NavigationView sender, NavigationViewSelectionChangedEventArgs e)
        {
            if(e.IsSettingsSelected)
            {
                this.contentFrame.Navigate(typeof(SampleSettingPage));
            }
            else
            {
                NavigationViewItem selectedItem = e.SelectedItem as NavigationViewItem;

                string selectedItemTag = selectedItem.Tag as string;

                sender.Header = "Sample Page " + selectedItemTag.Substring(selectedItemTag.Length - 1);

                string pageName = "TestProject." + selectedItemTag;

                Type pageType = Type.GetType(pageName);

                this.contentFrame.Navigate(pageType);
            }
        }

        #endregion
        #region Left mode  ư üũ óϱ - leftModeRadioButton_Checked(sender, e)

        /// <summary>
        /// Left mode  ư üũ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void leftModeRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            if((sender as RadioButton).IsChecked == true)
            {
                this.navigationView.PaneDisplayMode = NavigationViewPaneDisplayMode.Left;
                this.navigationView.IsPaneOpen      = true;
            }
        }

        #endregion
        #region Top mode  ư üũ óϱ - topModeRadioButton_Checked(sender, e)

        /// <summary>
        /// Top mode  ư üũ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void topModeRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            if((sender as RadioButton).IsChecked == true)
            {
                this.navigationView.PaneDisplayMode = NavigationViewPaneDisplayMode.Top;
                this.navigationView.IsPaneOpen      = false;
            }
        }

        #endregion
        #region LeftCompact mode  ư üũ óϱ - leftCompactModeRadioButton_Checked(sender, e)

        /// <summary>
        /// LeftCompact mode  ư üũ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void leftCompactModeRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            if((sender as RadioButton).IsChecked == true)
            {
                this.navigationView.PaneDisplayMode = NavigationViewPaneDisplayMode.LeftCompact;
                this.navigationView.IsPaneOpen      = false;
            }
        }

        #endregion
    }
}